#include <common.h>
#include <asm/arch/hardware.h> 

#ifdef CFG_MATRIX400
void matrix400_gpio_init(void){
	/* GPIO16->READY, GPIO17->BUZZER*/
	HAL_GPIO_SET_DIRECTION_OUTPUT(MATRIX400_READY|MATRIX400_BUZZER);
	HAL_GPIO_SET_DATA_OUT_HIGH(MATRIX400_READY|MATRIX400_BUZZER);
	HAL_GPIO_SET_DIRECTION_OUTPUT(MATRIX400_RTC_SCLK);
	HAL_GPIO_SET_DATA_OUT_LOW(MATRIX400_RTC_SCLK);
	HAL_GPIO_SET_DIRECTION_OUTPUT(MATRIX400_RTC_REST);
	HAL_GPIO_SET_DATA_OUT_LOW(MATRIX400_RTC_REST);
	/* Init I2C Interface */
	HAL_GPIO_SET_DIRECTION_INPUT(MATRIX400_I2C_SDA);
	HAL_GPIO_SET_DIRECTION_INPUT(MATRIX400_I2C_SCL);
	HAL_GPIO_SET_DATA_OUT_HIGH(MATRIX400_I2C_SDA);
	HAL_GPIO_SET_DATA_OUT_HIGH(MATRIX400_I2C_SCL);
	{
	volatile int *pMEM_BANK1_CFG = (int *)0x30000008;
	volatile int *pMEM_BANK1_TIME = (int *)0x3000000C;
	
	*pMEM_BANK1_CFG = 0x120000b0;
	*pMEM_BANK1_TIME = 0x0003f330;
	
	HAL_GPIO_SET_DIRECTION_OUTPUT(GPIO_19_MASK|GPIO_20_MASK|GPIO_12_MASK|GPIO_13_MASK);
	/* set COM1, COM2 to RS232 mode */
	HAL_GPIO_SET_DATA_OUT_LOW(GPIO_19_MASK|GPIO_12_MASK);
	HAL_GPIO_SET_DATA_OUT_HIGH(GPIO_20_MASK|GPIO_13_MASK);	
	}
}

/*void MATRIX400_I2C_INIT(void){
	
	HAL_GPIO_SET_DIRECTION_INPUT(MATRIX400_I2C_SDA);
	HAL_GPIO_SET_DIRECTION_INPUT(MATRIX400_I2C_SCL);
	HAL_GPIO_SET_DATA_OUT_HIGH(MATRIX400_I2C_SDA);
	HAL_GPIO_SET_DATA_OUT_HIGH(MATRIX400_I2C_SCL);
}
*/
void MATRIX400_I2C_ACTIVE(void){
	HAL_GPIO_SET_DIRECTION_OUTPUT(MATRIX400_I2C_SDA);
	
}

void MATRIX400_I2C_TRISTATE(void){
	HAL_GPIO_SET_DIRECTION_INPUT(MATRIX400_I2C_SDA);
	
}

void MATRIX400_SDA(int bit){
	HAL_GPIO_SET_DIRECTION_OUTPUT(MATRIX400_I2C_SDA);
	if(bit)
		HAL_GPIO_SET_DATA_OUT_HIGH(MATRIX400_I2C_SDA);
	else
		HAL_GPIO_SET_DATA_OUT_LOW(MATRIX400_I2C_SDA);
}

void MATRIX400_SCL(int bit){
	HAL_GPIO_SET_DIRECTION_OUTPUT(MATRIX400_I2C_SCL);
	if(bit)
		HAL_GPIO_SET_DATA_OUT_HIGH(MATRIX400_I2C_SCL);
	else
		HAL_GPIO_SET_DATA_OUT_LOW(MATRIX400_I2C_SCL);
}

BOOL MATRIX400_I2C_READ(void){
	int state;

	HAL_GPIO_SET_DIRECTION_INPUT(MATRIX400_I2C_SDA);
	HAL_GPIO_READ_DATA_IN_STATE(state);
	return ((state >> MATRIX400_SDA_GPIO)&0x01);
	
	
}
#endif