/*
 * define version number
 */
#ifndef VERSION_MAJOR_NUM
#define VERSION_MAJOR_NUM	0
#endif

#ifndef VERSION_MINOR_NUM
#define VERSION_MINOR_NUM	14
#endif

#ifndef VERSION_CLOCK
#define VERSION_CLOCK		SYSTEM_CLOCK
#endif


/*
 * define STR9100 platform
 */


#define STR9102_PLATFORM	1
#define STR9104_PLATFORM	2
#define STR9203_PLATFORM	4


#ifndef CONFIG_STR9100_PLATFORM
#define CONFIG_STR9100_PLATFORM	(STR9102_PLATFORM)
//#define CONFIG_STR9100_PLATFORM	(STR9104_PLATFORM)
#endif



/*
 * define Data Bus Width of DDRC
 */
#define DDRC_DATA_BUS_WIDTH_16	(0)		/* the data bus width of DDRC */
#define DDRC_DATA_BUS_WIDTH_32	(1)


#if ((CONFIG_STR9100_PLATFORM == STR9203_PLATFORM) || (CONFIG_STR9100_PLATFORM == STR9102_PLATFORM))

#define DDRC_DATA_BUS_WIDTH	(DDRC_DATA_BUS_WIDTH_32)

#elif (CONFIG_STR9100_PLATFORM == STR9104_PLATFORM)

#define DDRC_DATA_BUS_WIDTH	(DDRC_DATA_BUS_WIDTH_16)

#else

#error "Incorrect STR9100 Hardware Platform Setting!!"

#endif


/*
 * Note the DDR SDRAM module used on STR9100 hardware platform is x16 device
 */
#define DDRC_SDRAM_SIZE_64MBIT	(0)		/* the size of individual DDR SDRAM module */
#define DDRC_SDRAM_SIZE_128MBIT	(1)
#define DDRC_SDRAM_SIZE_256MBIT	(2)
#define DDRC_SDRAM_SIZE_512MBIT	(3)

#define DDRC_SDRAM_MODULE_SIZE	(DDRC_SDRAM_SIZE_256MBIT)





/*
 * define system clock 
 */
#ifndef SYSTEM_CLOCK
#define SYSTEM_CLOCK		100000000
#endif

/*
 * define UART clock
 */
#ifndef UART_CLOCK
#define UART_CLOCK		48000000
#endif


/*
 * define flash bank
 */
#ifndef CONFIG_FLASH_BANK
#define CONFIG_FLASH_BANK	0
#endif